platform.apilevel = '2.0'     
-- Snake lua, by Vincent Stranz

-- Initialisation des Variables   
partie="menu"
menu=1
option={1,1,5,2,4}
color={{0,255,0},{0,255,255},{0,0,255},{255,255,0}}
hiscore = var.recall("hiscore")
if not hiscore then
    hiscore = {0,0,0}
end
if not level then
    level="EAS"
end    

function on.reset()
    x={49,59,69,79,89}
    y={100,100,100,100,100} -- Coordonnees initiales du snake
    lenght=5 -- Longueur du snake
    dir="right" -- Direction 
    tent=5
    temgc=88
    tem=0
    score=0
    food="false"
    timer.start(0.1)
end

on.reset()

--Initialisation de la nourriture
food1="true"
while food1=="true" do
    ver=0
    foodx=math.random(1,30) foody=math.random(1,17) foodx=foodx*10-1 foody=foody*10
        for k=1,lenght do
            if foodx==x[k] and foody==y[k] then
                ver=1
            end
        end
        if ver==0 then food1="false" end  
end  

function on.resize()
    w=platform.window:width()
    h=platform.window:height()
end

cnt=1
function on.timer()

    if partie=="menu" then
        tent=tent+1
        if tent==15 then
            tent=0
        end
        platform.window:invalidate()
    elseif partie=="jeu" then
        tem=tem+1
        if tem>=50 and tem<75 then
            temgc=temgc-3.5
            platform.window:invalidate()
        end
        if tem==50 then        
            food2="true"
            while food2=="true" do
                ver=0
                foodx2=math.random(1,30) foody2=math.random(1,17) foodx2=foodx2*10-1 foody2=foody2*10
                for k=1,lenght do
                    if foodx2==x[k] and foody2==y[k] then
                        ver=1
                    end
                end
                if ver==0 then food2="false" end  
            end       
        elseif tem==75 then
            tem=0
            foodx2=0
            foody2=0
            temgc=88
        end
                
        if food=="false" then
            if dir=="right" then
                table.remove(x,1)
                table.remove(y,1)
                x[lenght]=x[lenght-1]+10
                y[lenght]=y[lenght-1]
            elseif dir=="left" then
                table.remove(x,1)
                table.remove(y,1)
                x[lenght]=x[lenght-1]-10
                y[lenght]=y[lenght-1]
            elseif dir=="up" then
                table.remove(x,1)
                table.remove(y,1)
                x[lenght]=x[lenght-1]
                y[lenght]=y[lenght-1]-10
            elseif dir=="down" then
                table.remove(x,1)
                table.remove(y,1)
                x[lenght]=x[lenght-1]
                y[lenght]=y[lenght-1]+10
            end
            platform.window:invalidate()                
        elseif food=="true" then
            lenght=lenght+1
            if dir=="right" then
                x[lenght]=x[lenght-1]+10
                y[lenght]=y[lenght-1]
            elseif dir=="left" then
                x[lenght]=x[lenght-1]-10
                y[lenght]=y[lenght-1]
            elseif dir=="down" then
                x[lenght]=x[lenght-1]
                y[lenght]=y[lenght-1]+10
            elseif dir=="up" then
                x[lenght]=x[lenght-1]
                y[lenght]=y[lenght-1]-10
            end
            food="false"
            platform.window:invalidate()
               
        end                
        
        if x[lenght]==foodx and y[lenght]==foody then 
            food="true"
            score=score+1           
            food1="true"
            while food1=="true" do
                ver=0
                foodx=math.random(1,30) foody=math.random(1,17) foodx=foodx*10-1 foody=foody*10
                for k=1,lenght do
                    if foodx==x[k] and foody==y[k] then
                        ver=1
                    end
                end
                if ver==0 then food1="false" end  
            end       
        end
        if x[lenght]==foodx2 and y[lenght]==foody2 then 
            tem=0
            temgc=88
            score=score+3 
            food="true"
        end        
        
        for k=1,lenght-1 do 
            if x[k]==x[lenght] and y[k]==y[lenght] or x[lenght]>=w-11 or x[lenght]<= 1 or y[lenght]<=1 or y[lenght]>=h-31 then                 
                cnt=cnt+1
                if cnt==2 then score2=score end
                on.reset()
                partie="perdu"
                on.highscore()
                platform.window:invalidate() 
            end 
        end                   
    end
    if partie=="perdu" then
            tent=tent+1
            if tent==15 then
                tent=0
            end
            platform.window:invalidate()
    end  
end

function on.highscore()
    if score2>hiscore[1] and level=="EAS" or score2>hiscore[2] and level=="MOD" or score2>hiscore[3] and level=="DIF" then
        if level=="EAS" then
            hiscore[1]=score2
            var.store("hiscore",hiscore)
        elseif level=="MOD" then
            hiscore[2]=score2
            var.store("hiscore",hiscore)
        elseif level=="DIF" then
            hiscore[3]=score2
            var.store("hiscore",hiscore)
        end
    end
end

function on.enterKey()
    if partie=="menu" then
        cnt=1
        partie="jeu"
        platform.window:invalidate()
        timer.start(time)
    elseif partie=="perdu" then
       partie="menu"
       timer.start(0.01)
       platform.window:invalidate()
    end
end

function on.paint(gc)
    
    gc:setColorRGB(color[2][1],color[2][2],color[2][3])
    gc:fillRect(0,0,w,h)
    gc:setColorRGB(color[3][1],color[3][2],color[3][3])
    gc:setPen("thick")
    gc:fillRect(0,0,w,10) gc:fillRect(w-8,0,10,h) gc:fillRect(0,h-20,w,20) gc:fillRect(0,0,10,h)
    gc:setColorRGB(0,0,0)
    gc:setPen("medium")
    gc:drawRect(8,9,w-16,h-30)
            
    if partie=="menu" then
        gc:setColorRGB(color[1][1],color[1][2],color[1][3])
        gc:fillRect(w/4+2,h/4.5+2,2*(w/4)-3,117)
        gc:setColorRGB(0,0,0) gc:setPen("medium")
        gc:drawRect(w/4,h/4.5,2*(w/4),120)
        gc:setColorRGB(color[1][1],color[1][2],color[1][3])
        gc:setFont("serif","b",19)
        gc:setColorRGB(0,0,0)
        gc:drawString("SNAKE",107,47)
        gc:setFont("serif","b",9)
        gc:drawString("DIFFICULTY",90,65) gc:drawString("COLORS",90,80) gc:drawString("MENU",90,95) gc:drawString("BACKGROUND",90,110) gc:drawString("WALLS",90,125) gc:drawString("SNAKE",90,140) if tent>=0 and tent<=10 then gc:drawString("PRESS ENTER",120,159) end   
        gc:setColorRGB(0,0,0)
        gc:setFont("serif","b",10)
        if level=="EAS" then srecord="HIGHSCORE : "..tostring(hiscore[1]) elseif level=="MOD" then srecord="HIGHSCORE : "..tostring(hiscore[2]) elseif level=="DIF" then srecord="HIGHSCORE : "..tostring(hiscore[3]) end
        gc:drawString(srecord,w/2-50,h-4)
        gc:setFont("sansserif","r",6)
        gc:drawString("By Vincent S",132,183)
        
        for k=58,133,15 do
            gc:fillPolygon({185,k-5,180,k,185,k+5,185,k-5})            
            gc:fillPolygon({225,k-4,229,k,225,k+5,225,k-4})
        end
        gc:setColorRGB(color[1][1],color[1][2],color[1][3])
        gc:fillRect(225,68,5,10) gc:fillRect(180,68,5,10)
        gc:setColorRGB(0,0,0)
        on.options(gc)
    elseif partie=="jeu" then
        gc:setColorRGB(color[4][1],color[4][2],color[4][3])
        gc:setPen("thin")
        for k=1,lenght do
            gc:setColorRGB(color[4][1],color[4][2],color[4][3])
            gc:fillRect(x[k],y[k],10,10)
            gc:setColorRGB(0,0,0)
            gc:drawRect(x[k],y[k],10,10)            
        end
        gc:setColorRGB(255,0,0)
        gc:fillArc(foodx,foody,10,10,0,360)
        gc:setColorRGB(0,0,0)
        gc:drawArc(foodx,foody,10,10,0,360)
        
        if dir=="up" then 
            gc:setColorRGB(255,255,255) 
            gc:fillArc(x[lenght]+6,y[lenght],5,5,0,360) 
            gc:fillArc(x[lenght],y[lenght],5,5,0,360) 
            gc:setColorRGB(0,0,0) 
            gc:drawArc(x[lenght]+6,y[lenght]-1,5,5,0,360) 
            gc:drawArc(x[lenght]-1,y[lenght]-1,5,5,0,360) 
            gc:fillArc(x[lenght]+8,y[lenght],2,2,0,360) 
            gc:fillArc(x[lenght]+1,y[lenght],2,2,0,360) 
        elseif dir=="down" then 
            gc:setColorRGB(255,255,255) 
            gc:fillArc(x[lenght]+6,y[lenght]+7,5,5,0,360) 
            gc:fillArc(x[lenght],y[lenght]+7,5,5,0,360) 
            gc:setColorRGB(0,0,0) 
            gc:drawArc(x[lenght]+6,y[lenght]+7,5,5,0,360) 
            gc:drawArc(x[lenght]-1,y[lenght]+7,5,5,0,360) 
            gc:fillArc(x[lenght]+8,y[lenght]+10,2,2,0,360) 
            gc:fillArc(x[lenght]+1,y[lenght]+10,2,2,0,360) 
        elseif dir=="right" then 
            gc:setColorRGB(255,255,255) 
            gc:fillArc(x[lenght]+7,y[lenght]+6,5,5,0,360) 
            gc:fillArc(x[lenght]+7,y[lenght]-1,5,5,0,360) 
            gc:setColorRGB(0,0,0) 
            gc:drawArc(x[lenght]+7,y[lenght]+6,5,5,0,360) 
            gc:drawArc(x[lenght]+7,y[lenght]-1,5,5,0,360) 
            gc:fillArc(x[lenght]+10,y[lenght]+8,2,2,0,360) 
            gc:fillArc(x[lenght]+10,y[lenght]+1,2,2,0,360) 
        else  
            gc:setColorRGB(255,255,255) 
            gc:fillArc(x[lenght]-2,y[lenght]+6,5,5,0,360) 
            gc:fillArc(x[lenght]-2,y[lenght]-1,5,5,0,360) 
            gc:setColorRGB(0,0,0) 
            gc:drawArc(x[lenght]-2,y[lenght]+6,5,5,0,360) 
            gc:drawArc(x[lenght]-2,y[lenght]-1,5,5,0,360) 
            gc:fillArc(x[lenght]-1,y[lenght]+8,2,2,0,360) 
            gc:fillArc(x[lenght]-1,y[lenght]+1,2,2,0,360) 
        end
        
        gc:setFont("sansserif","b",10)
        gc:setPen("thin") 
        gc:setColorRGB(255,255,255) 
        gc:fillRect(180,h-13,90,7) 
        gc:setColorRGB(0,0,0)
        gc:drawString("SCORE :",60,h-3) 
        gc:drawString(tostring(score),120,h-3)        
        gc:drawString("SCORE :",60,h-3)         
        gc:drawRect(180,h-13,90,7)
        
        if tem>=50 and tem<75 then
            gc:setColorRGB(0,155,0)
            gc:fillArc(foodx2,foody2,10,10,0,360)
            gc:fillRect(181,h-12,temgc,5)
            gc:setColorRGB(0,0,0)
            gc:drawArc(foodx2,foody2,10,10,0,360)            
        end    
    elseif partie=="perdu" then
        gc:setColorRGB(0,0,0)
        gc:setFont("serif","b",20)
        gc:drawString("GAME OVER!",w/2-gc:getStringWidth("GAME OVER!")/2,80)
        gc:setFont("serif","b",11)
        gc:drawString("SCORE :"..tostring(score2),w/2-gc:getStringWidth("SCORE :"..tostring(score2))/2,100)
        gc:setFont("serif","b",9)
        if tent>=0 and tent<=10 then gc:drawString("PRESS ENTER",w/2-gc:getStringWidth("PRESS ENTER")/2,159) end            
    end

end

function on.arrowKey(key)
    if partie=="menu" then
        
        if key=="down" and menu~=5 then
            menu=menu+1           
        elseif key=="up" and menu~=1 then
            menu=menu-1           
        elseif key=="down" and menu==5 then 
            menu=1
        elseif key=="up" and menu==1 then
            menu=5
        end
        platform.window:invalidate()
        
        if menu==1 then
            if key=="right" and option[1]~=3  then
                option[1]=option[1]+1
            elseif key=="left" and option[1]~=1 then
                option[1]=option[1]-1
            elseif key=="left" and option[1]==1 then
                option[1]=3
            elseif key=="right" and option[1]==3 then
                option[1]=1
            end        
        else
            if key=="right" and option[menu]~=6  then
                option[menu]=option[menu]+1
            elseif key=="left" and option[menu]~=1 then
                option[menu]=option[menu]-1
            elseif key=="left" and option[menu]==1 then
                option[menu]=6
            elseif key=="right" and option[menu]==6 then
                option[menu]=1                
            end            
            platform.window:invalidate()
        end        
                    
    elseif partie=="jeu"  then
        if key=="right" and dir~="left" then
            dir=key
        elseif key=="left" and dir~="right" then
            dir=key
        elseif key=="up" and dir~="down" then
            dir=key
        elseif key=="down" and dir~="up" then
            dir=key
        end        
    end
end

function on.charIn(key)
    if partie=="jeu" then
        if key=="6" and dir~="left" then
            dir="right"
        elseif key=="4" and dir~="right" then
            dir="left"
        elseif key=="8" and dir~="down" then
            dir="up"
        elseif key=="2" and dir~="up" then
            dir="down"
        end        
    end
end

function on.escapeKey()     
    partie="menu"
    on.reset()
    platform.window:invalidate()                  
end


function on.options(gc)
    gc:setColorRGB(0,0,0)
    if menu==1 then sy=55 elseif menu==2 then sy=85 elseif menu==3 then sy=100 elseif menu==4 then sy=115 elseif menu==5 then sy=130 end
    if menu~=1 then 
        if option[menu]==1 then color[menu-1]={0,255,0} elseif option[menu]==2 then color[menu-1]={0,0,255} elseif option[menu]==3 then color[menu-1]={255,0,0} elseif option[menu]==4 then color[menu-1]={255,255,0} elseif option[menu]==5 then color[menu-1]={0,255,255} elseif option[menu]==6 then color[menu-1]={255,0,255} end
    end    
    gc:fillArc(82,sy+1,5,5,0,360)
    gc:setFont("serif","b",9)
    if option[1]==1 then level="EAS" time=0.5 elseif option[1]==2  then level="MOD" time=0.2 elseif option[1]==3 then level="DIF" time=0.1 end   
    gc:drawString(level,193,65)
    gc:setPen("thin")
    gc:setColorRGB(color[1][1],color[1][2],color[1][3])
    gc:fillRect(195,83,20,10)
    gc:setColorRGB(color[2][1],color[2][2],color[2][3])
    gc:fillRect(195,98,20,10)
    gc:setColorRGB(color[3][1],color[3][2],color[3][3])
    gc:fillRect(195,113,20,10)
    gc:setColorRGB(color[4][1],color[4][2],color[4][3])
    gc:fillRect(195,128,20,10)
    gc:setColorRGB(0,0,0)
    for ry=83,128,15 do
        gc:drawRect(195,ry,20,10)
    end    
end